'==============================================================================
'
'  Sort utility for PowerBASIC Console Compiler
'  Copyright (c) 1998 by PowerBASIC, Inc. All Rights Reserved.
'
'  Like the DOS SORT.EXE utility, this program accepts text via STDIN,
'  sorts it (case insensitive) and writes the sorted text to STDOUT.
'
'  As a Win32 console application it supports long filenames and text
'  files are large as virtual memory (2 gigabytes maximum).
'
'==============================================================================

DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD

FUNCTION PbMain() AS LONG

    LOCAL count AS LONG
    LOCAL x     AS LONG

    LOCAL tc1 as DWORD
    LOCAL tc2 as DWORD
    LOCAL tc3 as DWORD
    LOCAL tc4 as DWORD

    tc1 = GetTickCount

    DIM text(1 to 1000000) AS STRING

    WHILE NOT STDEOF
      INCR count
      STDIN LINE text(count)
    WEND

    tc2 = GetTickCount

    ARRAY SORT text(1) FOR count, ASCEND        ''' COLLATE UCASE

    tc3 = GetTickCount

    FOR x = 1 TO count
      STDOUT text(x)
    NEXT x

    tc4 = GetTickCount

    STDERR "---------------------------------------------"
    STDERR "Load string array ="+str$(tc2 - tc1)+" ms"
    STDERR "PB Array Sort     ="+str$(tc3-tc2)+" ms"
    STDERR "String Output     ="+str$(tc4-tc3)+" ms"
    STDERR "---------------------------------------------"

END FUNCTION
