' 
'
    #include "\pbwin80\include\win32api.inc"

    DECLARE FUNCTION asmcode() as DWORD
    DECLARE FUNCTION ltok(ByVal src as DWORD,ByVal pArray as DWORD) as DWORD
    DECLARE FUNCTION wtok(ByVal pText as DWORD,ByVal pArray as DWORD) as DWORD
    DECLARE FUNCTION szappend(ByVal pstring as DWORD,ByVal buffer as DWORD,ByVal location as DWORD) as DWORD
    DECLARE FUNCTION StrLen(ByVal item as DWORD) as DWORD
    DECLARE FUNCTION szCopy(ByVal src as DWORD,ByVal dst as DWORD) as DWORD

    MACRO fssort(func,arg1,arg2,arg3)
      ! push arg3
      ! push arg2
      ! push arg1
      ! call func
    END MACRO

' 

FUNCTION PBmain as LONG

    LOCAL pstr as DWORD
    LOCAL psrt as DWORD
    LOCAL pMem as DWORD
    LOCAL acnt as DWORD
    LOCAL lcnt as DWORD
    LOCAL parr as DWORD
    LOCAL tc1  as DWORD
    LOCAL tc2  as DWORD
    LOCAL hMem as DWORD
    LOCAL flen as DWORD
    LOCAL cloc as DWORD
    LOCAL bwrt as DWORD
    LOCAL arr  as DWORD
    LOCAL pcln as DWORD
    LOCAL wcnt as DWORD
    LOCAL clar as DWORD
    LOCAL pinp as DWORD
    LOCAL hFile as DWORD

    LOCAL ptxt as DWORD
    LOCAL buffer as ASCIIZ * 32768

    LOCAL plf  as DWORD
    LOCAL lf   as ASCIIZ * 8

    plf = VarPtr(lf)

    lf   = chr$(13,10)                      ' create a CRLF string
    ptxt = VarPtr(buffer)                   ' get text buffer address
    pcln = GetCommandLine                   ' get address of command line
    szCopy pcln,ptxt                        ' copy the command line to a buffer

    wcnt = wtok(ptxt,ByVal varPtr(clar))    ' tokenise words in the command line

  ' -------------------------------------------------
  ' check for the correct command line argument count
  ' -------------------------------------------------
    if wcnt <> 3 Then
      StdOut "Incorrect number of command line arguments"
      Exit FUNCTION
    End if

    dim clargs(2) as ASCIIZ PTR at clar         ' dimension the command line args as ASCIIZ

  ' -----------------------------------------------------
  ' open input file and read it into memory buffer "pstr"
  ' -----------------------------------------------------
    hFile = CreateFile(@clargs(1),%GENERIC_READ,ByVal 0, _
            ByVal 0,%OPEN_EXISTING,%FILE_ATTRIBUTE_NORMAL,ByVal 0)
    flen = GetFileSize(hFile,0)
    pstr = GlobalAlloc(%GMEM_FIXED,flen)
    ReadFile hFile,ByVal pstr,flen,ByVal VarPtr(bwrt),ByVal 0
    CloseHandle hFile

    psrt = asmcode                              ' get address of the asm sort
    acnt = ltok(pstr,ByVal VarPtr(pMem))        ' tokenise the lines of text from the input source

    tc1 = GetTickCount                          ' set up timing
    fssort(psrt,pMem,acnt,0)                    ' use macro to call asm sort function
    tc2 = GetTickCount                          ' end the timing

    dim tline(acnt) as DWORD at pMem            ' dim a DWORD array at pMem
    hMem = GlobalAlloc(%GMEM_FIXED,flen)        ' allocate a buffer to append results to

  ' -----------------------------------------
  ' append sorted results to allocated buffer
  ' -----------------------------------------
    cloc = 0                                    ' set the current location pointer
    lcnt = 0                                    ' zero the loop counter

    Do
      cloc = szappend(hMem,tline(lcnt),cloc)    ' append the string
      cloc = szappend(hMem,plf,cloc)            ' append a CRLF pair
      ! add lcnt, 1
    Loop while lcnt < acnt

  ' ---------------------------------------------------
  ' create the result file and write the result to file
  ' ---------------------------------------------------
    hFile = CreateFile(@clargs(2),%GENERIC_WRITE,ByVal 0, _
            ByVal 0,%CREATE_ALWAYS,%FILE_ATTRIBUTE_NORMAL,ByVal 0)
    WriteFile hFile,ByVal hMem,cloc,ByVal VarPtr(bwrt),ByVal 0
    CloseHandle hFile

    Stdout ltrim$(str$(acnt))+" lines sorted in"+str$(tc2-tc1)+" ms written to file "+@clargs(2)
                              

    GlobalFree pMem
    GlobalFree hMem
    GlobalFree pstr

End FUNCTION

' 

FUNCTION szCopy(ByVal src as DWORD,ByVal dst as DWORD) as DWORD

    #REGISTER NONE

    ! mov esi, src
    ! mov edi, dst
    ! or ebx, -1

  ' -----------
  ' unroll by 4
  ' -----------
  lbl0:
    ! add ebx, 1
    ! movzx eax, BYTE PTR [esi+ebx]
    ! mov [edi+ebx], al
    ! test eax, eax
    ! jz lbl1

    ! add ebx, 1
    ! movzx eax, BYTE PTR [esi+ebx]
    ! mov [edi+ebx], al
    ! test eax, eax
    ! jz lbl1

    ! add ebx, 1
    ! movzx eax, BYTE PTR [esi+ebx]
    ! mov [edi+ebx], al
    ! test eax, eax
    ! jz lbl1

    ! add ebx, 1
    ! movzx eax, BYTE PTR [esi+ebx]
    ! mov [edi+ebx], al
    ! test eax, eax
    ! jnz lbl0

  lbl1:

END FUNCTION

' 

FUNCTION szappend(ByVal pstring as DWORD,ByVal buffer as DWORD,ByVal location as DWORD) as DWORD

    #REGISTER NONE

  ' ------------------------------------------------------
  ' pstring     the main buffer to append extra data to.
  ' buffer      the byte data to append to the main buffer
  ' location    current location pointer
  ' ------------------------------------------------------

    ! mov edi, 1

    ! or eax, -1
    ! mov esi, pstring        ' pstring
    ! mov ecx, buffer         ' buffer
    ! add esi, location       ' location ' add offset pointer to source address

  ' -----------
  ' unroll by 2
  ' -----------
  lbl0:
    ! add eax, edi
    ! movzx edx, BYTE PTR [ecx+eax]
    ! mov [esi+eax], dl
    ! test edx, edx
    ! jz lbl1                 ' exit on written terminator

    ! add eax, edi
    ! movzx ebx, BYTE PTR [ecx+eax]
    ! mov [esi+eax], bl
    ! test ebx, ebx
    ! jnz lbl0                ' exit on written terminator

  lbl1:
    ! add eax, location       ' location ' return updated offset pointer
    ! mov FUNCTION, eax

END FUNCTION

' 

FUNCTION ltok(ByVal src as DWORD,ByVal pArray as DWORD) as DWORD

    #REGISTER NONE

    LOCAL pTxt as DWORD
    LOCAL pmem as DWORD
    LOCAL bcnt as DWORD

  ' ---------------------------------------------------------------
  ' tokenise lines in a text source writing an array of pointers
  ' to the address of "pArray" and returning the line count in EAX.
  '
  ' The address written to the variable "pArray" should be released
  ' within the same scope as the variable with a call to GlobalFree()
  ' when the pointer array is no longer required.
  '
  ' EXAMPLE
  ' cnt = ltok(ptxt,ByVal VarPtr(harr))    ' tokenise source lines
  ' dim tline(cnt) as ASCIIZ PTR at harr   ' treat it as an ASCIIZ PTR array.
  ' .....
  ' GlobalFree harr                        ' deallocate memory from "ltok"
  ' ---------------------------------------------------------------

    pTxt = src

    ! mov edi, 1                      ' set counter to 1 in case of no trailing CRLF

    ! mov esi, pTxt
    ! sub esi, 1
  ' ----------------
  ' count line feeds
  ' ----------------
  lbl0:
    ! add esi, 1
    ! movzx edx, BYTE PTR [esi]
    ! test edx, edx                   ' test for terminator
    ! jz lbl1
    ! cmp edx, 10                     ' test for line feed
    ! jne lbl0
    ! add edi, 1                      ' lf count in EDI
    ! jmp lbl0
  lbl1:
  ' --------------------
  ' multiply result by 4
  ' --------------------
    ! add edi, edi
    ! add edi, edi
    ! mov bcnt, edi

    pmem = GlobalAlloc(%GMEM_FIXED or %GMEM_ZEROINIT,bcnt)

    ! mov edi, pmem                   ' copy allocated memory address into EDI
    ! mov esi, pTxt
    ! xor eax, eax                    ' zero arg counter
    ! sub esi, 1
    ! jmp ftrim

  ' ---------------------------------

  terminate:
    ! mov BYTE PTR [esi], 0           ' terminate end of current line

  ftrim:                              ' scan to find next acceptable character
    ! add esi, 1
    ! movzx edx, BYTE PTR [esi]       ' zero extend byte
    ! test edx, edx                   ' test for zero terminator
    ! jz lout
    ! cmp edx, 32
    ! jbe ftrim                       ' scan again for 32 or less

  ' ========
    ! mov [edi], esi                  ' write current location to pointer
    ! add edi, 4                      ' set next pointer location
    ! add eax, 1                      ' increment arg count return value
  ' ========

  ttrim:                              ' scan to find the next CR or LF
    ! add esi, 1
    ! movzx edx, BYTE PTR [esi]       ' zero extend byte
    ! cmp edx, 13
    ! jg ttrim                        ' short loop on normal case

    ! je terminate
    ! cmp edx, 10                     ' extra test for ascii 10
    ! je terminate
    ! test edx, edx
    ! jnz ttrim                       ' loop back if not zero, IE TAB.

  ' ---------------------------------

  lout:
    ! mov esi, pArray                 ' load passed handle address into ESI
    ! mov ecx, pmem                   ' local memory handle into ECX
    ! mov [esi], ecx                  ' store local array handle at address of passed handle

    ! mov FUNCTION, eax               ' return the line count

END FUNCTION

' 

FUNCTION wtok(ByVal pText as DWORD,ByVal pArray as DWORD) as DWORD

    #REGISTER NONE

    LOCAL var1 as DWORD
    LOCAL var2 as DWORD

  ' -------------------------------------------------
  ' tokenise an array of words based on the character
  ' range specified in the following table and return
  ' an array of pointers to the tokens.
  ' -------------------------------------------------
  ' Note that if you modify the table you should not change
  ' the single or double quote as their capacity is built
  ' into the following algorithm.
  '
  ' The memory handle to the pointer array written to the
  ' variable "pArray" should be released within the same
  ' scope as the variable with a call to GlobalFree().
  ' -------------------------------------------------------

    ! xor ebx, ebx                    ' zero the array counter

    StrLen pText                      ' get the buffer length
    ! add eax, eax                    ' set pointer array size
    ! mov var1, eax

    GlobalAlloc %GMEM_FIXED or %GMEM_ZEROINIT,var1    ' allocate pointer array      
    ! mov edx, eax

  ' ======================
    ! mov esi, pText                  ' text address in ESI
    ! sub esi, 1
    ! mov edi, edx                    ' array address in EDI
  ' ======================

  badchar:
    ! add esi, 1
    ! movzx eax, BYTE PTR [esi]       ' zero extend byte
    ! test eax, eax                   ' test for zero terminator
    ! jz endsrc                       ' exit on terminator
    ! cmp BYTE PTR chtbl[eax], 0      ' test if bad character in table
    ! je badchar                      ' loop back for next if it is

  ' ========
    ! mov [edi], esi                  ' write current location to pointer array
    ! add edi, 4                      ' set next array write location
    ! add ebx, 1                      ' increment the array counter
  ' ========

    ! cmp eax, 39                     ' is character a single quote ?
    ! je squote
    ! cmp eax, 34                     ' is character a double quote ?
    ! je dquote

  goodchar:
    ! add esi, 1
    ! movzx eax, BYTE PTR [esi]       ' zero extend byte
    ! test eax, eax                   ' test for zero terminator
    ! jz endsrc                       ' exit on terminator
    ! cmp BYTE PTR chtbl[eax], 0      ' test if bad character in table
    ! jne goodchar                    ' loop back for next if its not

  ' ========
    ! mov BYTE PTR [esi], 0           ' overwrite trailing bad char with zero
    ! jmp badchar
  ' ========

  squote:                             ' single quote
    ! add esi, 1
    ! movzx eax, BYTE PTR [esi]
    ! test eax, eax
    ! jz qterror
    ! sub eax, 39
    ! jnz squote

    ! add esi, 1
    ! mov BYTE PTR [esi], 0
    ! jmp badchar

  dquote:                             ' double quote
    ! add esi, 1
    ! movzx eax, BYTE PTR [esi]
    ! test eax, eax
    ! jz qterror
    ! sub eax, 34
    ! jnz dquote

    ! add esi, 1
    ! mov BYTE PTR [esi], 0
    ! jmp badchar

  ' ======================

  ' The label "qterror" currently resolves to the same address as the
  ' following label "endsrc" but it is put in place if a user wants to
  ' modify this algorithm to flag a quotation error in the source text

  qterror:
  ' ----------------------------------------
  ' write quotation error handling code here
  ' ----------------------------------------

  endsrc:

' -------------------------------------------------------------------------

  ' -------------------------
  ' multiply array count by 4
  ' -------------------------
    ! mov eax, ebx                    ' EBX is the array count
    ! add eax, eax
    ! add eax, eax

  ' ----------------------
  ' truncate unused memory
  ' ----------------------
    ! mov var1, eax
    ! mov var2, edx

    GlobalReAlloc var2,var1,0         ' EDX is the allocate memory handle being reallocated

  ' -----------------------------------
  ' copy the local array handle back
  ' to the address of the passed handle
  ' -----------------------------------
    ! mov esi, pArray                 ' load passed handle address into EDX
    ! mov DWORD PTR [esi], eax        ' store local array handle at address of passed handle

    ! mov FUNCTION, ebx               ' return the array member count
    EXIT FUNCTION

  chtbl:
    ! db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    ! db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    ! db 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    ! db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1


END FUNCTION

' 

FUNCTION StrLen(ByVal item as DWORD) as DWORD

    #REGISTER NONE

    ! mov     eax, item               ' get pointer to string
    ! lea     edx, [eax+3]            ' pointer+3 used in the end
    ! mov     ebx, &H80808080

  lbl0:
  ' --------------------
  ' manually unroll by 3
  ' --------------------
    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' increment pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jnz     nxt

    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' increment pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jnz     nxt

    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' increment pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jnz     nxt
  ' --------------------
    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' 4 increment DWORD pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jz      lbl0                    ' no zero bytes, continue loop

  nxt:
    ! test    ecx, &H00008080         ' test first two bytes
    ! jnz     lbl1
    ! shr     ecx, 16                 ' not in the first 2 bytes
    ! add     eax, 2
  lbl1:
    ! shl     cl, 1                   ' use carry flag to avoid branch
    ! sbb     eax, edx                ' compute length

    ! mov FUNCTION, eax

END FUNCTION

' 

FUNCTION asmcode() as DWORD

    LOCAL rval as DWORD

    FUNCTION = CodePtr(ssort)

    Exit FUNCTION

' ====================================

ssort:

    ! sub    esp, &H14
    ! push   ebx
    ! push   ebp
    ! push   esi
    ! mov    esi,  [esp+&H24]
    ! push   edi
    ! mov    edi,  [esp+&H2C]
    ! cmp    edi, 10
    ! jle    sst1
  sst18:
    ! mov    eax, edi
    ! cdq
    ! sub    eax, edx
    ! mov    ebx, eax
    ! xor    ecx, ecx
    ! sar    ebx, 1
    ! cmp    edi, &H32
    ! lea    ebp, [edi-1]
    ! jle    sst2
    ! mov    ecx,  [esp+&H30]
    ! mov    eax, edi
    ! cdq
    ! and    edx, 7
    ! add    eax, edx
    ! mov    edi, eax
    ! push   ecx
    ! sar    edi, 3
    ! lea    eax, [edi+edi]
    ! push   eax
    ! push   edi
    ! push   0
    ! push   esi
    ! mov    [esp+&H3C], eax
    ! call   med3func

    ! mov    edx, [esp+&H30]
    ! push   edx
    ! mov    [esp+&H20], eax
    ! lea    eax, [edi+ebx]
    ! push   eax
    ! push   ebx
    ! sub    ebx, edi
    ! push   ebx
    ! push   esi
    ! call   med3func

    ! mov    ecx, [esp+&H30]
    ! push   ecx
    ! push   ebp
    ! mov    edx, ebp
    ! sub    ebp, [esp+&H30]
    ! sub    edx, edi
    ! push   edx
    ! push   ebp
    ! push   esi
    ! mov    ebx, eax
    ! call   med3func
    ! mov    ecx, [esp+&H1C]
    ! mov    edi, [esp+&H2C]
    ! mov    ebp, eax

  sst2:
    ! mov    eax, [esp+&H30]
    ! push   eax
    ! push   ebp
    ! push   ebx
    ! push   ecx
    ! push   esi
    ! call   med3func

    ! mov    edx, [esi+eax*4]
    ! mov    ecx, [esi]
    ! mov    [esi], edx
    ! mov    [esi+eax*4], ecx
    ! mov    ecx, [esi]
    ! mov    eax, [esp+&H30]
    ! movsx  ecx, BYTE PTR [ecx+eax]
    ! mov    ebx, 1
    ! cmp    edi, ebx
    ! mov    [esp+&H10], ecx
    ! jle    sst3

  sst5:
    ! mov    edx,  [esi+ebx*4]
    ! movsx  edx, BYTE PTR [edx+eax]
    ! cmp    edx, ecx
    ! jne    sst3
    ! cmp    ebx, edi
    ! je     sst4
    ! add    ebx, 1
    ! cmp    ebx, edi
    ! jl     sst5

  sst3:
    ! add    edi, &H0FFFFFFFF
    ! mov    ebp, edi
    ! mov    eax, ebx
    ! mov    [esp+&H28], ebp
    ! jmp    sst6
    ! lea    ecx, [ecx]

  sst6:
    ! cmp    eax, edi
    ! jg     sst7

  ' +++++++++++++++++++++++++++++++++++++++

  sst10:
    ! mov    ecx, [esi+eax*4]
    ! mov    edx, [esp+&H30]
    ! movsx  edx, BYTE PTR [ecx+edx]

    ! mov    ebp, [esp+&H10]
    ! cmp    edx, ebp
    ! jg     sst8
    ! jne    sst9

    ! mov    edx,  [esi+ebx*4]
    ! mov    [esi+ebx*4], ecx
    ! mov    [esi+eax*4], edx
    ! add    ebx, 1
  sst9:
    ! add    eax, 1
    ! cmp    eax, edi
    ! jle    sst10

  ' +++++++++++++++++++++++++++++++++++++++

  sst21:
    ! mov    ebp,  [esp+&H28]

  sst7:
    ! mov    edx, eax
    ! sub    edx, ebx
    ! cmp    ebx, edx
    ! mov    [esp+&H1C], edx
    ! jg     sst11
    ! mov    edx, ebx

  sst11:
    ! test   edx, edx
    ! jle    sst12
    ! mov    ecx, eax
    ! sub    ecx, edx
    ! lea    ecx, [esi+ecx*4]
    ! mov    [esp+&H28], esi
    ! mov    [esp+&H14], ecx
    ! mov    [esp+&H18], edx
    ! lea    esp, [esp]

  sst13:
    ! mov    edx,  [esp+&H28]
    ! mov    edx,  [edx]
    ! mov    ecx,  [ecx]
    ! mov    [esp+&H20], edx
    ! mov    edx,  [esp+&H28]
    ! add    DWORD PTR [esp+&H28], 4
    ! mov    [edx], ecx
    ! mov    ecx,  [esp+&H14]
    ! mov    edx,  [esp+&H20]
    ! mov    [ecx], edx
    ! add    ecx, 4
    ! sub    DWORD PTR [esp+&H18], 1
    ! mov    [esp+&H14], ecx
    ! jne    sst13

  sst12:
    ! mov    edx, [esp+&H2C]
    ! sub    edx, ebp
    ! mov    ecx, ebp
    ! sub    ecx, edi
    ! add    edx, &H0FFFFFFFF
    ! cmp    ecx, edx
    ! mov    [esp+&H18], ecx
    ! jg     sst14
    ! mov    edx, ecx

  sst14:
    ! test   edx, edx
    ! jle    sst15
    ! mov    ecx,  [esp+&H2C]
    ! sub    ecx, edx
    ! lea    eax, [esi+eax*4]
    ! lea    ecx, [esi+ecx*4]
    ! mov    [esp+&H28], edx
    ! lea    ebx, [ebx]

  ' ------------------------------------

  sst16:
    ! mov    edx,  [eax]
    ! mov    [esp+&H20], edx
    ! mov    edx, [ecx]
    ! mov    [eax], edx
    ! mov    edx, [esp+&H20]
    ! mov    [ecx], edx
    ! add    eax, 4
    ! add    ecx, 4
    ! sub    DWORD PTR [esp+&H28], 1
    ! jne    sst16

  ' ------------------------------------
  
  sst15:
    ! mov    eax, [esp+&H30]
    ! mov    ecx, [esp+&H1C]
    ! push   eax
    ! push   ecx
    ! push   esi
    ! call   ssort

    ! cmp    DWORD PTR [esp+&H10], 0
    ! je     sst17
    ! mov    edx, [esp+&H30]
    ! mov    eax, [esp+&H2C]
    ! add    edx, 1
    ! push   edx
    ! mov    edx, [esp+&H20]
    ! sub    ebx, ebp
    ! lea    ecx, [ebx+eax-1]
    ! push   ecx
    ! lea    eax, [esi+edx*4]
    ! push   eax
    ! call   ssort

  sst17:
    ! mov    ecx,  [esp+&H18]
    ! sub    edi, ebp
    ! add    edi, [esp+&H2C]
    ! mov    [esp+&H2C], ecx
    ! lea    esi, [esi+edi*4]
    ! mov    edi, ecx

  sst20:
    ! cmp    edi, &H0A
    ! jg     sst18

  sst1:
    ! mov    edx, [esp+&H30]
    ! push   edx
    ! push   edi
    ! push   esi
    ! call   insort

  sst19:
    ! pop    edi
    ! pop    esi
    ! pop    ebp
    ! pop    ebx
    ! add    esp, &H14
    ! ret    &H0C

  sst4:
    ! test   ecx, ecx
    ! je     sst19
    ! add    eax, 1
    ! mov    [esp+&H30], eax
    ! jmp    sst20

  sst8:
    ! cmp    eax, edi
    ! jg     sst21
    ! jmp    sst22
    ! lea    ecx, [ecx]

  sst22:
    ! mov    ecx,  [esi+edi*4]
    ! mov    edx,  [esp+&H30]
    ! movsx  edx, BYTE PTR [ecx+edx]
    ! cmp    edx, ebp
    ! jl     sst23
    ! mov    ebp,  [esp+&H28]
    ! jne    sst24
    ! mov    edx,  [esi+ebp*4]
    ! mov    [esi+edi*4], edx
    ! mov    [esi+ebp*4], ecx
    ! sub    ebp, 1
    ! mov    [esp+&H28], ebp

  sst24:
    ! sub    edi, 1
    ! cmp    eax, edi
    ! jg     sst7
    ! mov    ebp,  [esp+&H10]
    ! jmp    sst22

  sst23:
    ! cmp    eax, edi
    ! jg     sst21
    ! mov    edx,  [esi+edi*4]
    ! mov    ecx,  [esi+eax*4]
    ! mov    ebp,  [esp+&H28]
    ! mov    [esi+eax*4], edx
    ! mov    [esi+edi*4], ecx
    ! add    eax, 1
    ! sub    edi, 1
    ! jmp    sst6

' 

insort:

    ! push   ebx
    ! push   esi
    ! push   edi
    ! push   ebp
    ! xor    ebp, ebp
    ! mov    ebx,  [esp+&H14]
    ! sub    DWORD PTR [esp+&H1C], 1

  ist1:
    ! add    ebp, 1
    ! test   ebp, ebp
    ! jle    ist1
    ! cmp    ebp,  [esp+&H18]
    ! jge    ist2
    ! mov    eax, ebp

  ist5:
    ! mov    edx,  [esp+&H1C]
    ! mov    esi,  [ebx+eax*4]
    ! mov    edi,  [ebx+eax*4-4]

  ist4:
    ! add    edx, 1
    ! movzx  ecx, BYTE PTR [edx+esi]
    ! cmp    cl, BYTE PTR [edx+edi]
    ! jl     ist3
    ! jg     ist1
    ! test   ecx, ecx
    ! je     ist1
    ! add    edx, 1
    ! movzx  ecx, BYTE PTR [edx+esi]
    ! cmp    cl, BYTE PTR [edx+edi]
    ! jl     ist3
    ! jg     ist1
    ! test   ecx, ecx
    ! je     ist1
    ! add    edx, 1
    ! movzx  ecx, BYTE PTR [edx+esi]
    ! cmp    cl, BYTE PTR [edx+edi]
    ! jl     ist3
    ! jg     ist1
    ! test   ecx, ecx
    ! je     ist1
    ! add    edx, 1
    ! movzx  ecx, BYTE PTR [edx+esi]
    ! cmp    cl, BYTE PTR [edx+edi]
    ! jl     ist3
    ! jg     ist1
    ! test   ecx, ecx
    ! je     ist1
    ! add    edx, 1
    ! movzx  ecx, BYTE PTR [edx+esi]
    ! cmp    cl, BYTE PTR [edx+edi]
    ! jl     ist3
    ! jg     ist1
    ! test   ecx, ecx
    ! je     ist1
    ! add    edx, 1
    ! movzx  ecx, BYTE PTR [edx+esi]
    ! cmp    cl, BYTE PTR [edx+edi]
    ! jl     ist3
    ! jg     ist1
    ! test   ecx, ecx
    ! je     ist1
    ! add    edx, 1
    ! movzx  ecx, BYTE PTR [edx+esi]
    ! cmp    cl, BYTE PTR [edx+edi]
    ! jl     ist3
    ! jg     ist1
    ! test   ecx, ecx
    ! je     ist1
    ! add    edx, 1
    ! movzx  ecx, BYTE PTR [edx+esi]
    ! cmp    cl, BYTE PTR [edx+edi]
    ! jl     ist3
    ! jg     ist1
    ! test   ecx, ecx
    ! jne    ist4
    ! jmp    ist1
    ! mov    edi, edi

  ist3:
    ! mov    [ebx+eax*4], edi
    ! mov    [ebx+eax*4-4], esi
    ! sub    eax, 1
    ! jg     ist5
    ! jmp    ist1

  ist2:
    ! pop    ebp
    ! pop    edi
    ! pop    esi
    ! pop    ebx
    ! ret    12

' ====================================

med3func:

    ! mov    edx, [esp+4]
    ! mov    eax, [esp+8]
    ! mov    ecx, [edx+eax*4]
    ! push   ebp
    ! mov    ebp, [esp+&H10]
    ! push   esi
    ! mov    esi, [edx+ebp*4]
    ! push   edi
    ! mov    edi, [esp+&H20]
    ! movsx  ecx, BYTE PTR [ecx+edi]
    ! movsx  esi, BYTE PTR [esi+edi]
    ! cmp    ecx, esi
    ! je     med1
    ! push   ebx
    ! mov    ebx, [esp+&H20]
    ! mov    edx, [edx+ebx*4]
    ! movsx  edx, BYTE PTR [edx+edi]
    ! cmp    edx, ecx
    ! je     med2
    ! cmp    edx, esi
    ! je     med2
    ! cmp    ecx, esi
    ! jge    med3
    ! cmp    esi, edx
    ! jl     med4
    ! cmp    ecx, edx
    ! jl     med2
    ! pop    ebx
    ! pop    edi
    ! pop    esi
    ! pop    ebp
    ! ret    &H14

  med3:
    ! cmp    esi, edx
    ! jle    med5

  med4:
    ! pop    ebx
    ! pop    edi
    ! pop    esi
    ! mov    eax, ebp
    ! pop    ebp
    ! ret    &H14

  med5:
    ! cmp    ecx, edx
    ! jl     med6

  med2:
    ! mov    eax, ebx

  med6:
    ! pop    ebx

  med1:
    ! pop    edi
    ! pop    esi
    ! pop    ebp

    ! ret    &H14

' ====================================

END FUNCTION

' 
